// TimeValidator: Control behavior of QLineEdit requesting time value (limit)

#include "TimeValidator.moc"
#include <ctype.h>
#include <qstring.h>

TimeValidator::TimeValidator(QLineEdit *parent, const char * name=0):QValidator(parent,name)
{
}
TimeValidator::~TimeValidator()
{
}
QValidator::State TimeValidator::validate(QString &input, int &pos)
{
	for(unsigned int i=0;i<strlen(input);i++)
		if(!isdigit(input[i])&&input[i]!='-')
			return QValidator::Invalid;
	if(strchr(input,'-') && (strchr(input,'-')-input)!=4) // - has to be at pos. 5
		return QValidator::Invalid;
	if(pos==4 && strlen(input)==4) { // Add the - automatically...
		input+="-";
		pos=5;
	}
	if(strchr(input,'-')!=strrchr(input,'-')) // we want exactly one -
		return QValidator::Invalid;
	if((strlen(input)==9 && input[4]=='-') || strlen(input)==0) // Working time = xxxx-xxxx or empty
		return QValidator::Acceptable;
	return QValidator::Valid;
}
void TimeValidator::fixup(QString &input)
{
	// Not yet implemented...
}
